package SOFA.demos.protodemo;

public class BeastImpl implements Runnable {
  SOFA.Component.DCUP.DCUPComponentManagerImpl cm;
 
  WorkInterface WorkRequirement;
  boolean end; 
  boolean stopped;

  public BeastImpl(SOFA.Component.DCUP.DCUPComponentManagerImpl _cm) {
    end = false;
    stopped = false;
    cm = _cm;
  }

  private void setRequirement() throws SOFA.Component.NamingException {
    WorkRequirement = (WorkInterface) cm.getRequirement("worker");
  }

  public void run() {
    System.out.println("Started thread" );
    try {
      setRequirement();
    } catch (SOFA.Component.NamingException e) {
      throw new SOFA.SOFAnode.Run.SOFARuntimeException("Bad requirements", e);
    }
    System.out.println("Requirements found, starting work");
    
    WorkRequirement.start();
    while (!end) {
      WorkRequirement.doit();
      try {
        Thread.currentThread().sleep(1000);
      } catch (Exception e) {
        ;
      }
    }
    System.out.println("Finishing work");
    WorkRequirement.finish();
    stopped = true;
  }

  public void setEnd() {
    end = true;
  }

  public boolean isStopped() {
    return stopped;
  }
}
